<?php

/**
 * registro_etapa actions.
 *
 * @package    cobro_coactivo
 * @subpackage registro_etapa
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
require_once 'HTMLPurifier.auto.php';
require 'HTMLPurifier.autoload.php';

class registro_etapaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_REGISTRO_ETAPA',
        'CBR_PROCESO_COACTIVO',
        'CBR_REMISION_TITULO',
        'CBR_TITULO_MINERO_V',
        'CBR_ACTUACION_PROC'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_proceso_coactivo' => 'CBR_REGISTRO_ETAPA'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_PROCESO_COACTIVO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ACTUACION_PROC' =>
        array(
            'id_actuacion_proc' => 'CBR_REGISTRO_ETAPA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_REGISTRO_ETAPA' =>
        array(
            'id_registro_etapa' => 'id_registro_etapa',
            'id_proceso_coactivo' => 'id_proceso_coactivo',
            'id_actuacion_proc' => 'id_actuacion_proc',
            'numero' => 'numero',
            'fecha' => 'fecha',
            'observaciones' => 'observaciones',
            //'detalle_plantilla' => 'detalle_plantilla',
            'adjunto' => 'adjunto',
            'id_plantilla' => 'id_plantilla',
            'estado' => 'estado',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'fecha_aprueba' => 'fecha_aprueba',
            'usuario_aprueba' => 'usuario_aprueba'
        ),
        'CBR_PROCESO_COACTIVO' =>
        array(
            'id_remision_titulo' => 'id_remision_titulo',
            'no_proceso' => 'no_proceso',
            'fecha' => 'fecha_coactivo',
            'id_anhos' => 'id_anhos'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'fecha_remision' => 'fecha_remision',
            'estado' => 'estado_titulo',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_ACTUACION_PROC' =>
        array(
            'descripcion' => 'descripcion_actuacion',
            'notificacion' => 'notificacion'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'orden'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_REGISTRO_ETAPA' =>
        array(
            'id_registro_etapa,a' => array('!=' => array(-1)),
            'id_registro_etapa,b' => array('=' => array('id_investiga_bienes')),
            'id_proceso_coactivo' => array('=' => array('id_proceso_coactivo')),
            'id_actuacion_proc' => array('=' => array('id_actuacion_proc')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_registro_etapa'; //identificador de la tabla
    protected $id_names = array('id_registro_etapa'); //llave primaria
    protected $field_names = array('id_proceso_coactivo', 'id_actuacion_proc', 'numero', 'fecha',
        'observaciones', 'detalle_plantilla', 'adjunto', 'id_plantilla', 'estado', 'usuario_log', 'fecha_aprueba', 'usuario_aprueba'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_REGISTRO_ETAPA'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_registro_etapa'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_registro_etapa = $list_data_post[0]['id_registro_etapa'];

                if (isset($request['id_plantilla'])) {

                    $id_plantilla = $request['id_plantilla'];

                    $sql = <<<EOD
UPDATE CBR_REGISTRO_ETAPA SET DETALLE_PLANTILLA=(select detalle from cbr_plantilla where id_plantilla = $id_plantilla) where id_registro_etapa=$id_registro_etapa
EOD;

                    $this->conn->execute($sql);
                }

                //Actualizacion del consecutivo
                if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {


                    $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    $id_anhos = $records[0]['id_anhos'];
                    $id_tipo_documento = $list_data_post[0]['id_tipo_documento'];
                    $consecutivo = $list_data_post[0]['numero'];


                    //Valida exista consecutivo - 20170424
                    if ($consecutivo != 1) {

                        $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo = $consecutivo  
    where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                    } else {

                        $sql = <<<EOD
Insert into CBR_CONSECUTIVO_DOC (ID_CONSECUTIVO_DOC,ID_TIPO_DOCUMENTO,ID_ANHOS,CONSECUTIVO) 
    values (null,'$id_tipo_documento','$id_anhos','$consecutivo') 
EOD;
                    }

                    $this->conn->execute($sql);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {
                $id_registro_etapa = $list_data_post[0]['id_registro_etapa'];

                if ($request['id_plantilla'] != "") {
                    $id_plantilla = $request['id_plantilla'];
                    $sql = <<<EOD
UPDATE CBR_REGISTRO_ETAPA SET FECHA= trunc(sysdate) where id_registro_etapa=$id_registro_etapa
EOD;


                    $this->conn->execute($sql);
                }

                //Actualizacion del consecutivo
                if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {


                    $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    $id_anhos = $records[0]['id_anhos'];
                    $id_actuacion_proc = $list_data_post[0]['id_actuacion_proc'];
                    $consecutivo = $list_data_post[0]['numero'];
                    $consecutivo = $consecutivo * 1;

                    $sql = <<<EOD
select id_tipo_documento from cbr_actuacion_proc where id_actuacion_proc = $id_actuacion_proc
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    $id_tipo_documento = $records[0]['id_tipo_documento'];

                    //Valida exista consecutivo - 20170424
                    if ($consecutivo != 1) {

                        $sql = <<<EOD
update cbr_consecutivo_doc set consecutivo = $consecutivo  
    where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                    } else {

                        $sql = <<<EOD
Insert into CBR_CONSECUTIVO_DOC (ID_CONSECUTIVO_DOC,ID_TIPO_DOCUMENTO,ID_ANHOS,CONSECUTIVO) 
    values (null,'$id_tipo_documento','$id_anhos','$consecutivo') 
EOD;
                    }

                    $this->conn->execute($sql);
                }

                //COMMIT DE TODAS LAS TRANSACCIONES
                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            if (!isset($request['detalle']) || $request['detalle'] == '') {
                $request['detalle'] = "Sin registro de Plantilla";
            }

            //Campos de log - 20200221
            $request['usuario_log'] = $request['id_username'];

            //Actualizacion del consecutivo
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {

                $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                $records = CN_TABLE::executeSQL($sql);
                $id_anhos = $records[0]['id_anhos'];

                $id_actuacion_proc = $request['id_actuacion_proc'];

                $sql = <<<EOD
select id_tipo_documento from cbr_actuacion_proc where id_actuacion_proc = $id_actuacion_proc
EOD;
                $records = CN_TABLE::executeSQL($sql);
                $id_tipo_documento = $records[0]['id_tipo_documento'];


                $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc 
    where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                $records = CN_TABLE::executeSQL($sql);

                //Valida exista consecutivo - 20170424
                if (count($records) > 0) {
                    $logger->info("Consecutivo rec::" . $records[0]['consecutivo']);
                    $consecutivo = $records[0]['consecutivo'];
                    $request['numero'] = $consecutivo + 1;
                } else {
                    $logger->info("Consecutivo rec::1");
                    $request['numero'] = 1;
                }
                $request['numero'] = str_pad($request['numero'], 4, "0", STR_PAD_LEFT);
                $logger->info("Consecutivo numero::" . $request['numero']);

                $request['usuario_aprueba'] = $request['id_username'];
                $request['fecha_aprueba'] = CN_TABLE::fechaSistema();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            if (!isset($request['detalle']) || $request['detalle'] == '') {
                $request['detalle'] = "Sin registro de Plantilla";
            } else {
                //Limpiar el html - 20200304
                $valor = $request['detalle'];
                $valor_limpio = $purifier->purify($valor);
                $request['detalle'] = $valor_limpio;
            }

            //Actualizacion del consecutivo
            if (isset($request['aprueba_documento']) && $request['aprueba_documento'] == "true") {

                $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $id_anhos = $records[0]['id_anhos'];

                $id_actuacion_proc = $request['id_actuacion_proc'];

                $sql = <<<EOD
select id_tipo_documento from cbr_actuacion_proc where id_actuacion_proc = $id_actuacion_proc
EOD;
                $records = CN_TABLE::executeSQL($sql);
                $id_tipo_documento = $records[0]['id_tipo_documento'];


                $sql = <<<EOD
select consecutivo from cbr_consecutivo_doc 
    where id_tipo_documento= $id_tipo_documento and id_anhos = $id_anhos
EOD;
                $records = CN_TABLE::executeSQL($sql);

                //Valida exista consecutivo - 20170424
                if (count($records) > 0) {
                    $logger->info("Consecutivo rec::" . $records[0]['consecutivo']);
                    $consecutivo = $records[0]['consecutivo'];
                    $request['numero'] = $consecutivo + 1;
                } else {
                    $logger->info("Consecutivo rec::1");
                    $request['numero'] = 1;
                }
                $request['numero'] = str_pad($request['numero'], 4, "0", STR_PAD_LEFT);
                $logger->info("Consecutivo numero::" . $request['numero']);

                $request['usuario_aprueba'] = $request['id_username'];
                $request['fecha_aprueba'] = CN_TABLE::fechaSistema();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        $id_proceso_coactivo = $request['id_proceso_coactivo'];
        $id_actuacion_procesal = $request['id_actuacion_proc'];

        $sql = <<<EOD
select count(*) cantidad from cbr_registro_etapa
    where id_proceso_coactivo = $id_proceso_coactivo 
        and id_actuacion_proc = $id_actuacion_procesal
EOD;
        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Ya se ha registrado esta actuacion para el proceso";
            $errors['servicio'] = "registro_etapa";
        }

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
